VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Multi-Replace"
   ClientHeight    =   5520
   ClientLeft      =   45
   ClientTop       =   405
   ClientWidth     =   6795
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5520
   ScaleWidth      =   6795
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtFileExt 
      Height          =   285
      Left            =   4080
      TabIndex        =   5
      ToolTipText     =   "List the file extentions you want included in the search, seperated by ';'"
      Top             =   5160
      Width           =   1935
   End
   Begin VB.CheckBox chkCase 
      Caption         =   "Check1"
      Height          =   255
      Left            =   1440
      TabIndex        =   4
      Top             =   5160
      Width           =   255
   End
   Begin VB.CommandButton btnGo 
      Caption         =   "Go!"
      Height          =   495
      Left            =   6120
      TabIndex        =   6
      Top             =   4800
      Width           =   495
   End
   Begin VB.TextBox txtDir 
      Height          =   285
      Left            =   2160
      TabIndex        =   3
      Top             =   4785
      Width           =   3855
   End
   Begin VB.CommandButton btnChangeDir 
      Caption         =   "Change Directory"
      Height          =   495
      Left            =   240
      TabIndex        =   0
      Top             =   4800
      Width           =   975
   End
   Begin VB.TextBox txtReplace 
      Height          =   2175
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   2
      ToolTipText     =   "Place the text you want to replace here"
      Top             =   2520
      Width           =   6375
   End
   Begin VB.TextBox txtFind 
      Height          =   2175
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   1
      ToolTipText     =   "Place the text you want to find here"
      Top             =   240
      Width           =   6375
   End
   Begin VB.Label lblFileTypes 
      Alignment       =   1  'Right Justify
      Caption         =   "File Extensions:"
      Height          =   255
      Left            =   2760
      TabIndex        =   9
      ToolTipText     =   "List the file extentions you want included in the search, seperated by ';'"
      Top             =   5180
      Width           =   1215
   End
   Begin VB.Label lblMatchCase 
      Caption         =   "Match case"
      Height          =   255
      Left            =   1680
      TabIndex        =   8
      Top             =   5195
      Width           =   975
   End
   Begin VB.Label lblDir 
      Alignment       =   1  'Right Justify
      Caption         =   "Directory:"
      Height          =   255
      Left            =   1320
      TabIndex        =   7
      Top             =   4800
      Width           =   735
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub btnChangeDir_Click()
    Dim strChange As String
    strChange = GetFolder(Me.hWnd, "Select the folder that contains files you want text replaced in")
    If strChange <> "" Then txtDir.Text = strChange
End Sub

Private Sub btnGo_Click()
    If txtFind.Text = "" Then
        MsgBox "You must specify some text to search for.", vbCritical
        Exit Sub
    End If
    If txtDir.Text = "" Then
        MsgBox "You must specify the directory to search for files to replace the text in.", vbCritical
        Exit Sub
    End If
    If Dir(txtDir.Text, vbDirectory + vbHidden + vbReadOnly + vbSystem) = "" Then
        MsgBox "You have not specified a valid directory/file to process.", vbCritical
        Exit Sub
    End If
    Dim strFile As String
    Dim iFirstInstance As Long
    Dim bMatchCase As VbCompareMethod
    If chkCase.Value Then
        bMatchCase = vbBinaryCompare
    Else
        bMatchCase = vbTextCompare
    End If
    If Dir(txtDir.Text, vbReadOnly + vbHidden + vbSystem) <> "" Then 'is a file
        'Open txtDir.Text For Input As #1
        strFile = ReadFileSafe(txtDir.Text, 1)
        'Close #1
        iFirstInstance = InStr(1, strFile, txtFind.Text, bMatchCase)
        If iFirstInstance <> 0 Then
            strFile = Left$(strFile, iFirstInstance - 1) & Replace$(strFile, txtFind.Text, txtReplace.Text, iFirstInstance, -1, bMatchCase)
            Open txtDir.Text For Output As #1
            Print #1, strFile;
            Close #1
        End If
    Else
        Dim strFileExts As Variant
        txtFileExt.Text = Trim(txtFileExt.Text)
        If txtFileExt.Text = "" Then
            strFileExts = Null
        Else
            strFileExts = Split(Trim(txtFileExt.Text), ";")
        End If
        Dim strFolders As Variant
        strFolders = getSubFolders(txtDir.Text)
        ReDim Preserve strFolders(LBound(strFolders) To UBound(strFolders) + 1)
        strFolders(UBound(strFolders)) = txtDir.Text
        Dim i As Integer
        For i = LBound(strFolders) To UBound(strFolders)
            DoEvents
            Dim strFilePath As String
            strFilePath = Dir(strFolders(i) & "\*", vbReadOnly + vbHidden + vbSystem)
            Do While strFilePath <> ""
                Dim bRightExt As Boolean
                bRightExt = False
                If IsNull(strFileExts) Then
                    bRightExt = True
                Else
                    Dim strExt As Variant
                    For Each strExt In strFileExts
                        If InStrRev(strFilePath, strExt, -1, vbTextCompare) = Len(strFilePath) - Len(strExt) + 1 Then
                            bRightExt = True
                            Exit For
                        End If
                    Next
                End If
                If bRightExt Then
                    'Open strFolders(i) & "\" & strFilePath For Input As #1
                    strFile = ReadFileSafe(strFolders(i) & "\" & strFilePath, 1)
                    'Close #1
                    iFirstInstance = InStr(1, strFile, txtFind.Text, bMatchCase)
                    If iFirstInstance <> 0 Then
                        strFile = Left$(strFile, iFirstInstance - 1) & Replace$(strFile, txtFind.Text, txtReplace.Text, iFirstInstance, -1, bMatchCase)
                        Open strFolders(i) & "\" & strFilePath For Output As #1
                        Print #1, strFile;
                        Close #1
                    End If
                End If
                strFilePath = Dir
            Loop
        Next i
    End If
    MsgBox "Done", vbInformation
End Sub

Public Function ReadFileSafe(strFilePath As String, iFileNumber As Integer) As String
    Open strFilePath For Input As #iFileNumber
    ReadFileSafe = ""
    Do While Not EOF(iFileNumber)
        Dim strIn As String
        Line Input #iFileNumber, strIn
        ReadFileSafe = ReadFileSafe & vbCrLf & strIn
    Loop
    Close #iFileNumber
    ReadFileSafe = Right$(ReadFileSafe, Len(ReadFileSafe) - 2)
End Function

Private Sub lblMatchCase_Click()
    If chkCase.Value Then
        chkCase.Value = 0
    Else
        chkCase.Value = 1
    End If
End Sub

Public Function getSubFolders(folderPath As String) As Variant
    Dim getFolders As Variant
    getFolders = Array()
    
    Dim fs, f, f1, sf
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set f = fs.GetFolder(folderPath)
    Set sf = f.subFolders
    For Each f1 In sf
        ReDim Preserve getFolders(0 To UBound(getFolders) + 1)
        getFolders(UBound(getFolders)) = folderPath & "\" & f1.Name
        addSubFolders folderPath & "\" & f1.Name, getFolders
    Next
    Set fs = Nothing
    Set f = Nothing
    Set sf = Nothing

    DoEvents
    getSubFolders = getFolders
End Function

'Recursively called function, adds subfolders of folderPath to folderArray
Private Function addSubFolders(folderPath As String, ByRef folderArray As Variant)
    Dim fs, f, f1, sf
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set f = fs.GetFolder(folderPath)
    Set sf = f.subFolders
    For Each f1 In sf
        ReDim Preserve folderArray(0 To UBound(folderArray) + 1)
        folderArray(UBound(folderArray)) = folderPath & "\" & f1.Name
        addSubFolders folderPath & "\" & f1.Name, folderArray
    Next
    Set fs = Nothing
    Set f = Nothing
    Set sf = Nothing
    DoEvents
End Function
